stages:
  - lint
  - tests
  - build

image: gitlab/dind

.job-template: &lint-job-definition
  image: python:3.11.1-slim
  stage: lint
  before_script:
    - apt-get update && apt-get -y install --no-install-recommends curl make
    - make install
  tags:
    - docker
  only:
    - branches
    - tags


lint:
  <<: *lint-job-definition
  script:
    - make lint

tests:
  <<: *lint-job-definition
  stage: tests
  services:
    - name: postgres:13.8
      alias: postgres

  variables:
    # Postgres variables
    POSTGRES_DB: retrieval_system_db
    POSTGRES_USER: postgres
    POSTGRES_PASSWORD: postgres
  script:
    - export PYTHONPATH="$PYTHONPATH:."
    - sleep 10
    - make migrate test

build-image:
  stage: build
  services:
    - docker:dind
  before_script:
    - docker run --rm -i replicated/dockerfilelint:ad65813 < ./docker/Dockerfile
  script:
    - docker build --file ./docker/Dockerfile .
  tags:
    - docker
  only:
    - branches
    - tags
